//********************************************//
// Nettime.pas for  nettime.dll version 1.04  //
//                                            //
//                                            //
// Copyright by Michael Gasser 1999           //
//                                            //
// 8.10.1999                                  //
// eMail: theiler.gasser@bluewin.ch           //
//********************************************//

unit nettime;


interface

// error values:
const NETTIME_ERROR_RECEIVE   =   1;
      NETTIME_ERROR_RESOLVE   =   2;
      NETTIME_ERROR_TIMEOUT   =   3;
      NETTIME_ERROR_WINSOCK   = 101; // <==> wsockerror<>0
      NETTIME_ERROR_DISREGARD =   4; // SNTP only, see RFC 2030

(*  The most important
    indicator of an unhealthy server is the LI field, in which
    a value of 3 indicates an unsynchronized condition.
    When this value is displayed, clients should discard the
    server message, regardless of the contents of other
    fields.

    NETTIME_ERROR_DISREGARD iff
    ( leap = 3 ) or ( stratum > 15 ) or ( stratum = 0 ) or
     ((Transmit Timestamp = 0));

     *)


type cbf = procedure( time : TDateTime ; wsockerror, error : integer);

type Fourbytes = record
      case integer of
        0: ( b : array[1..4] of byte);
        1: ( i : integer);
      end;


type NTP_Time  = record
          seconds  : Fourbytes;
          fraction : Fourbytes;
     end;

type SNTPMsgFormat = record
       Info            : Fourbytes;
       root_delay      : Fourbytes;
       root_dispersion : Fourbytes;
       reference_id    : Fourbytes;

       ref_timestamp   : ntp_time; // not supported
       orig_timestamp  : ntp_time; // not supported , ori_time (see below) supported.
       rec_timestamp   : ntp_time;
       trans_timestamp : ntp_time;
     end;

type TSNTPInfoRec = record
               Leapindicator : integer;
               Version       : integer;
               Mode          : integer;
               Stratum       : integer;
               Poll          : integer;
               Precision     : double;
               Rootdelay     : double;
               Rootdispersion: double;
               Ref_Time,          // not supported
               Ori_Time,
               Rec_Time,
               Tra_Time      : TDateTime;
         end;


type cbfSNTP = procedure( time : TDateTime; HSNTPMsg : SNTPMsgFormat; hSNTPInfoRec : TSNTPInfoRec;
               wsockerror, error : integer );


procedure GetNetTime( host : PChar;
                      _port: PChar;
                      _timeout : integer;
                      p : cbf );

procedure GetSNTPNetTime( host : PChar;
                          _port: PChar;
                          _timeout : integer;
                          p : cbfSNTP );


implementation


procedure GetNetTime( host : PChar;
                      _port: PChar;
                      _timeout : integer;
                      p : cbf ); far; external 'nettime';

procedure GetSNTPNetTime( host : PChar;
                          _port: PChar;
                          _timeout : integer;
                          p : cbfSNTP );far;external 'nettime';


end.
